package com.hungraim.ism.service.impl;

import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import com.hungraim.ism.dao.DisableApplyMapper;
import com.hungraim.ism.dao.FndDistrictMapper;
import com.hungraim.ism.dao.FndOrganMapper;
import com.hungraim.ism.dao.FndStreetMapper;
import com.hungraim.ism.pojo.vo.disable.DisableExamineInfoVO;
import com.hungraim.ism.pojo.vo.disable.DisableVO;
import com.hungraim.ism.pojo.vo.disable.ExamineRecord;
import com.hungraim.ism.service.DisableService;
import com.hungraim.ltc.pojo.entity.disable.ChDisableApply;
import com.hungraim.ltc.pojo.entity.disable.ChFndDistrict;
import com.hungraim.ltc.pojo.entity.disable.ChFndOrgan;
import com.hungraim.ltc.pojo.entity.disable.ChFndStreet;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import java.util.ArrayList;
import java.util.List;

@Service
public class DisableServiceImpl implements DisableService {

    @Autowired
    private DisableApplyMapper disableApplyMapper;
    @Autowired
    private FndDistrictMapper districtMapper;
    @Autowired
    private FndOrganMapper fndOrganMapper;
    @Autowired
    private FndStreetMapper fndStreetMapper;

    @Override
    public Page<DisableVO> disableList(String organId, String isIncludeSubsidiaries, String districtProvincial, String districtCity,
                                       String districtArea, String realName, String certiCode, String dataFrom,
                                       String srvOrganId, int page, int pageSize) {
        //拼接子机构id
        if ("0".equals(isIncludeSubsidiaries)) {
            boolean flag = true;
            while (flag) {
                QueryWrapper<ChFndOrgan> queryWrapper = new QueryWrapper<>();
                queryWrapper.eq("STATUS", "1");
                queryWrapper.eq("PARENT_ID", organId);
                List<ChFndOrgan> organs = fndOrganMapper.selectList(queryWrapper);
                if (organs != null && organs.size() != 0) {
                    for (ChFndOrgan chFndOrgan : organs) {
                        organId = organId + "," + chFndOrgan.getOrganId();
                        if ("2".equals(chFndOrgan.getIsLeaf())) {
                            flag = false;
                        }
                    }
                } else {
                    flag = false;
                }
            }
        }
        return disableApplyMapper.disableList(new Page<>(page, pageSize), organId, isIncludeSubsidiaries, districtProvincial,
                districtCity, districtArea, realName, certiCode, dataFrom, srvOrganId);
    }

    @Override
    public DisableExamineInfoVO disableExamineInfo(String applyId) {
        DisableExamineInfoVO disableExamineInfoVO = disableApplyMapper.selectDisableExamineInfoByApplyId(applyId);
        List<ExamineRecord> examineRecords = disableApplyMapper.listExamineRecordByApplyId(applyId);
        disableExamineInfoVO.setExamineRecords(examineRecords);
        return disableExamineInfoVO;
    }

    @Override
    public void addDisable(ChDisableApply chDisableApply) {
        disableApplyMapper.insert(chDisableApply);
    }

    @Override
    public void disableExamine(String applyId, String checkName, Short applyStatus, String checkRemark) {
        ChDisableApply chDisableApply = disableApplyMapper.selectById(applyId);
        chDisableApply.setCheckName(checkName);
        chDisableApply.setApplyStatus(applyStatus);
        chDisableApply.setCheckRemark(checkRemark);
    }

    @Override
    public List<ChFndDistrict> district(String districtLevel, String districtCode) {
        if ("4".equals(districtCode)) {
            QueryWrapper<ChFndStreet> queryWrapper = new QueryWrapper<>();
            queryWrapper.eq("AREA_CODE", districtCode);
            queryWrapper.eq("IS_VALID", 0);
            List<ChFndStreet> fndStreets = fndStreetMapper.selectList(queryWrapper);
            List<ChFndDistrict> resuts = new ArrayList<>();
            for (ChFndStreet chFndStreet : fndStreets) {
                ChFndDistrict chFndDistrict = new ChFndDistrict();
                chFndDistrict.setDistrictCode(chFndStreet.getStreetCode());
                chFndDistrict.setDistrictName(chFndStreet.getStreetName());
                chFndDistrict.setParentDistirctCode(chFndStreet.getAreaCode());
            }
            return resuts;
        } else {
            QueryWrapper<ChFndDistrict> queryWrapper = new QueryWrapper<>();
            queryWrapper.eq("IS_VALID", "Y");
            queryWrapper.eq("DISTRICT_LEVEL", districtLevel);
            if (!"1".equals(districtLevel)) {
                queryWrapper.eq("PARENT_DISTIRCT_CODE", districtCode);
            }
            return districtMapper.selectList(queryWrapper);
        }
    }

    @Override
    public List<ChFndOrgan> fndOrganRoot() {
        QueryWrapper<ChFndOrgan> queryWrapper = new QueryWrapper<>();
        queryWrapper.eq("IS_LEAF", "1");
        queryWrapper.and(wrapper -> wrapper.eq("PARENT_ID", "").or().eq("PARENT_ID", null));
        return fndOrganMapper.selectList(queryWrapper);
    }

}